diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPumice.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPumice.java
index 360b391c6..7edf9ef17 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPumice.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPumice.java
@@ -9,75 +9,77 @@ import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
 import org.lwjgl.opengl.GL11;
 
 public class BlockModelPumice<T extends BlockLogic> extends BlockModelStandard<T> {
     private boolean lavaFlag = false;
+
     public BlockModelPumice(Block<T> block) {
         super(block);
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
-        lavaFlag = true;
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        this.lavaFlag = true;
         boolean ob = renderBlocks.overbright;
         renderBlocks.overbright = true;
 //        block.setBlockBounds(0.005, 0.005, 0.005, 0.995, 0.995, 0.995);
-        boolean rendered = super.render(tessellator, worldSource, x, y, z);
+        boolean rendered = super.render(tessellator, worldSource, tilePos);
 
         renderBlocks.overbright = ob;
-        lavaFlag = false;
+        this.lavaFlag = false;
 //        block.setBlockBounds(0, 0, 0, 1, 1, 1);
-        rendered |= super.render(tessellator, worldSource, x, y, z);
+        rendered |= super.render(tessellator, worldSource, tilePos);
         return rendered;
     }
 
     @Override
     public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
-        if(renderBlocks.useInventoryTint) {
-            int color = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata, 0);
+        if (renderBlocks.useInventoryTint) {
+            int color = BlockColorDispatcher.getInstance().getDispatch(this.block).getFallbackColor(metadata, 0);
             float r = (float) (color >> 16 & 0xff) / 255F;
             float g = (float) (color >> 8 & 0xff) / 255F;
             float b = (float) (color & 0xff) / 255F;
             GL11.glColor4f(r * brightness, g * brightness, b * brightness, alpha);
-        }else {
+        } else {
             GL11.glColor4f(brightness, brightness, brightness, alpha);
         }
         float yOffset = 0.5F;
 
         GL11.glTranslatef(-0.5F, 0.0F - yOffset, -0.5F);
 
-        lavaFlag = true;
+        this.lavaFlag = true;
         boolean ob = renderBlocks.overbright;
         renderBlocks.overbright = true;
         final double depthFixOffset = 0.001d;
-        AABB bounds = AABB.fromPool(depthFixOffset, depthFixOffset, depthFixOffset, 1 - depthFixOffset, 1 - depthFixOffset, 1 - depthFixOffset);
+        AABBd bounds = new AABBd(depthFixOffset, depthFixOffset, depthFixOffset, 1 - depthFixOffset, 1 - depthFixOffset, 1 - depthFixOffset);
         renderBlockWithBounds(tessellator, bounds, metadata, brightness, alpha, LightmapHelper.getLightmapCoord(15, 15));
 
         renderBlocks.overbright = ob;
-        lavaFlag = false;
+        this.lavaFlag = false;
         if (LightmapHelper.isLightmapEnabled()) {
             lightmapCoordinate = Minecraft.getMinecraft().thePlayer.getLightmap(1f);
         }
-        bounds.set(0, 0, 0, 1, 1, 1);
+        bounds.setMin(0, 0, 0).setMax(1, 1, 1);
         renderBlockWithBounds(tessellator, bounds, metadata, brightness, alpha, lightmapCoordinate);
 
         GL11.glTranslatef(0.5F, yOffset, 0.5F);
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data) {
-        if (lavaFlag) return TextureRegistry.getTexture("minecraft:block/lava_still");
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data) {
+        if (this.lavaFlag) return TextureRegistry.getTexture("minecraft:block/lava_still");
         return super.getBlockTextureFromSideAndMetadata(side, data);
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockOverbrightTextureFromSideAndMeta(Side side, int data) {
-        if (lavaFlag) return TextureRegistry.getTexture("minecraft:block/lava_still");
+    public @Nullable IconCoordinate getBlockOverbrightTextureFromSideAndMeta(@NotNull Side side, int data) {
+        if (this.lavaFlag) return TextureRegistry.getTexture("minecraft:block/lava_still");
         return super.getBlockOverbrightTextureFromSideAndMeta(side, data);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java
index abbbf2c02..364a4033e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java
@@ -11,7 +11,7 @@ import net.minecraft.core.block.logic.RailDirection;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -31,30 +31,31 @@ public class BlockModelRail<T extends BlockLogicRail> extends BlockModelStandard
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
-        int meta = worldSource.getBlockMetadata(x, y, z);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        int meta = worldSource.getBlockData(tilePos);
         IconCoordinate icon = getBlockTextureFromSideAndMetadata(Side.BOTTOM, meta);
-        if(renderBlocks.overrideBlockTexture != null)
-        {
+        if (renderBlocks.overrideBlockTexture != null) {
             icon = renderBlocks.overrideBlockTexture;
         }
-        RailDirection railDirection = block.getLogic().getRailDirection(worldSource, new TilePos(x, y, z));
-		float brightness = 1.0f;
-		if(LightmapHelper.isLightmapEnabled()) {
-			if(renderBlocks.overbright) {
-				tessellator.setLightmapCoord(LightmapHelper.getOverbrightLightmapCoord(worldSource.getSavedLightValue(LightLayer.Sky, x, y, z)));
-			}else {
-				tessellator.setLightmapCoord(block.getLightmapCoord(worldSource, x, y, z));
-			}
-		}else {
-			if(!renderBlocks.overbright) {
-				brightness = renderBlocks.getBlockBrightness(worldSource, x, y, z);
-			}
-		}
-		if(renderBlocks.overbright) {
-			icon = getBlockOverbrightTexture(worldSource, x, y, z, Side.BOTTOM);
-		}
-        if(icon == null) { return false; }
+        RailDirection railDirection = this.block.getLogic().getRailDirection(worldSource, tilePos);
+        float brightness = 1.0f;
+        if (LightmapHelper.isLightmapEnabled()) {
+            if (renderBlocks.overbright) {
+                tessellator.setLightmapCoord(LightmapHelper.getOverbrightLightmapCoord(worldSource.getSavedLightValue(LightLayer.Sky, tilePos)));
+            } else {
+                tessellator.setLightmapCoord(this.block.getLightmapCoord(worldSource, tilePos));
+            }
+        } else {
+            if (!renderBlocks.overbright) {
+                brightness = renderBlocks.getBlockBrightness(worldSource, tilePos);
+            }
+        }
+        if (renderBlocks.overbright) {
+            icon = getBlockOverbrightTexture(worldSource, tilePos, Side.BOTTOM);
+        }
+        if (icon == null) {
+            return false;
+        }
 
         tessellator.setColorOpaque_F(brightness, brightness, brightness);
         final double minU = icon.getIconUMin();
@@ -62,39 +63,39 @@ public class BlockModelRail<T extends BlockLogicRail> extends BlockModelStandard
         final double minV = icon.getIconVMin();
         final double maxV = icon.getIconVMax();
         final float yOffset = 1 / 16f; // Offset from the ground
-        float vX1 = x + 1;
-        float vX2 = x + 1;
-        float vX3 = x;
-        float vX4 = x;
-        float vZ1 = z;
-        float vZ2 = z + 1;
-        float vZ3 = z + 1;
-        float vZ4 = z;
-        float vY1 = (float)y + yOffset;
-        float vY2 = (float)y + yOffset;
-        float vY3 = (float)y + yOffset;
-        float vY4 = (float)y + yOffset;
+        float vX1 = tilePos.x() + 1;
+        float vX2 = tilePos.x() + 1;
+        float vX3 = tilePos.x();
+        float vX4 = tilePos.x();
+        float vZ1 = tilePos.z();
+        float vZ2 = tilePos.z() + 1;
+        float vZ3 = tilePos.z() + 1;
+        float vZ4 = tilePos.z();
+        float vY1 = (float) tilePos.y() + yOffset;
+        float vY2 = (float) tilePos.y() + yOffset;
+        float vY3 = (float) tilePos.y() + yOffset;
+        float vY4 = (float) tilePos.y() + yOffset;
         switch (railDirection) {
             case STRAIGHT_EW:
             case SLOPE_E:
             case SLOPE_W:
             case TURN_WS:
-                vX1 = vX4 = x + 1;
-                vX2 = vX3 = x;
-                vZ1 = vZ2 = z + 1;
-                vZ3 = vZ4 = z;
+                vX1 = vX4 = tilePos.x() + 1;
+                vX2 = vX3 = tilePos.x();
+                vZ1 = vZ2 = tilePos.z() + 1;
+                vZ3 = vZ4 = tilePos.z();
                 break;
             case TURN_WN:
-                vX1 = vX2 = x;
-                vX3 = vX4 = x + 1;
-                vZ1 = vZ4 = z + 1;
-                vZ2 = vZ3 = z;
+                vX1 = vX2 = tilePos.x();
+                vX3 = vX4 = tilePos.x() + 1;
+                vZ1 = vZ4 = tilePos.z() + 1;
+                vZ2 = vZ3 = tilePos.z();
                 break;
             case TURN_EN:
-                vX1 = vX4 = x;
-                vX2 = vX3 = x + 1;
-                vZ1 = vZ2 = z;
-                vZ3 = vZ4 = z + 1;
+                vX1 = vX4 = tilePos.x();
+                vX2 = vX3 = tilePos.x() + 1;
+                vZ1 = vZ2 = tilePos.z();
+                vZ3 = vZ4 = tilePos.z() + 1;
                 break;
         }
         switch (railDirection) {
@@ -120,27 +121,26 @@ public class BlockModelRail<T extends BlockLogicRail> extends BlockModelStandard
         tessellator.addVertexWithUV(vX1, vY1, vZ1, maxU, minV);
         return true;
     }
+
     @Override
     public boolean shouldItemRender3d() {
         return false;
     }
+
     @Override
-    public @Nullable IconCoordinate getBlockOverbrightTexture(WorldSource blockAccess, int x, int y, int z, @NotNull Side side)
-    {
-        if (!block.getLogic().isPowered || (blockAccess.getBlockMetadata(x, y, z) & BlockLogicRail.MASK_POWERED) == 0) return null;
+    public @Nullable IconCoordinate getBlockOverbrightTexture(@NotNull WorldSource blockAccess, @NotNull TilePosc tilePos, @NotNull Side side) {
+        if (!this.block.getLogic().isPowered || (blockAccess.getBlockData(tilePos) & BlockLogicRail.MASK_POWERED) == 0)
+            return null;
 
-        return block == Blocks.RAIL_POWERED ? powerActiveOverlay : detectorActiveOverlay;
+        return this.block == Blocks.RAIL_POWERED ? this.powerActiveOverlay : this.detectorActiveOverlay;
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
-    {
-        if(block == Blocks.RAIL_POWERED && (data & BlockLogicRail.MASK_POWERED) != 0)
-        {
-            return powerActive;
-        } else if(!block.getLogic().isPowered && data >= 6)
-        {
-            return railCurve;
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data) {
+        if (this.block == Blocks.RAIL_POWERED && (data & BlockLogicRail.MASK_POWERED) != 0) {
+            return this.powerActive;
+        } else if (!this.block.getLogic().isPowered && data >= 6) {
+            return this.railCurve;
         }
         return super.getBlockTextureFromSideAndMetadata(side, data);
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRepeater.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRepeater.java
index 7eb2acc04..db6a31ca3 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRepeater.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRepeater.java
@@ -7,56 +7,56 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicRepeater;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
+import org.joml.primitives.AABBdc;
 
 public class BlockModelRepeater extends BlockModelStandard<BlockLogicRepeater> {
-	private static final BlockModelTorch<?> modelTorchActive = (BlockModelTorch<?>) BlockModelDispatcher.getInstance().getDispatch(Blocks.TORCH_REDSTONE_ACTIVE);
-    private static final BlockModelTorch<?> modelTorchIdle = (BlockModelTorch<?>) BlockModelDispatcher.getInstance().getDispatch(Blocks.TORCH_REDSTONE_IDLE);
+    private static final @NotNull BlockModelTorch<?> modelTorchActive = (BlockModelTorch<?>) BlockModelDispatcher.getInstance().getDispatch(Blocks.TORCH_REDSTONE_ACTIVE);
+    private static final @NotNull BlockModelTorch<?> modelTorchIdle = (BlockModelTorch<?>) BlockModelDispatcher.getInstance().getDispatch(Blocks.TORCH_REDSTONE_IDLE);
 
     public BlockModelRepeater(Block<BlockLogicRepeater> block) {
         super(block);
     }
 
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z){
-        int meta = worldSource.getBlockMetadata(x, y, z);
-        int i1 = meta & 3;
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        int meta = worldSource.getBlockData(tilePos);
+        int direction = meta & BlockLogicRepeater.MASK_DIRECTION;
 
-        switch(i1)
-        {
-            case 0: // '\0'
+        switch (direction) {
+            case BlockLogicRepeater.DIRECTION_SOUTH:
                 renderBlocks.uvRotateTop = 0;
                 break;
 
-            case 2: // '\002'
+            case BlockLogicRepeater.DIRECTION_NORTH:
                 renderBlocks.uvRotateTop = 3;
                 break;
 
-            case 3: // '\003'
+            case BlockLogicRepeater.DIRECTION_EAST:
                 renderBlocks.uvRotateTop = 2;
                 break;
 
-            case 1: // '\001'
+            case BlockLogicRepeater.DIRECTION_WEST:
                 renderBlocks.uvRotateTop = 1;
                 break;
         }
 
         int j1 = (meta & 0xc) >> 2;
-        renderBlocks.renderStandardBlock(tessellator, worldSource, this, block.getBlockBoundsFromState(worldSource, x, y, z), x, y, z);
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, this.block.getBoundsFromState(worldSource, tilePos), tilePos);
         renderBlocks.resetRenderBlocks();
         float brightness = 1.0f;
-        if(LightmapHelper.isLightmapEnabled()) {
-        	int lmc = block.getLightmapCoord(worldSource, x, y, z);
-        	if(block.emission > 0) {
-        		lmc = LightmapHelper.setBlocklightValue(lmc, 15);
-        	}
-        	tessellator.setLightmapCoord(lmc);
-        }else {
-    		brightness = renderBlocks.getBlockBrightness(worldSource, x, y, z);
-    		if(block.emission > 0 || Global.accessor.isFullbrightEnabled()) {
-    			brightness = 1.0f;
-    		}
+        if (LightmapHelper.isLightmapEnabled()) {
+            int lmc = this.block.getLightmapCoord(worldSource, tilePos);
+            if (this.block.emission > 0) {
+                lmc = LightmapHelper.setBlocklightValue(lmc, 15);
+            }
+            tessellator.setLightmapCoord(lmc);
+        } else {
+            brightness = renderBlocks.getBlockBrightness(worldSource, tilePos);
+            if (this.block.emission > 0 || Global.accessor.isFullbrightEnabled()) {
+                brightness = 1.0f;
+            }
         }
         tessellator.setColorOpaque_F(brightness, brightness, brightness);
         double d = -0.1875D;
@@ -64,46 +64,45 @@ public class BlockModelRepeater extends BlockModelStandard<BlockLogicRepeater> {
         double d2 = 0.0D;
         double d3 = 0.0D;
         double d4 = 0.0D;
-        switch(i1)
-        {
-            case 0: // '\0'
+        switch (direction) {
+            case BlockLogicRepeater.DIRECTION_SOUTH:
                 d4 = -0.3125D;
                 d2 = BlockLogicRepeater.torchPosOffset[j1];
                 break;
 
-            case 2: // '\002'
+            case BlockLogicRepeater.DIRECTION_NORTH:
                 d4 = 0.3125D;
                 d2 = -BlockLogicRepeater.torchPosOffset[j1];
                 break;
 
-            case 3: // '\003'
+            case BlockLogicRepeater.DIRECTION_EAST:
                 d3 = -0.3125D;
                 d1 = BlockLogicRepeater.torchPosOffset[j1];
                 break;
 
-            case 1: // '\001'
+            case BlockLogicRepeater.DIRECTION_WEST:
                 d3 = 0.3125D;
                 d1 = -BlockLogicRepeater.torchPosOffset[j1];
                 break;
         }
-        BlockModelTorch<?> modelTorch = block.getLogic().isRepeaterPowered ? modelTorchActive : modelTorchIdle;
-        if (renderBlocks.overbright && block.getLogic().isRepeaterPowered) {
-            modelTorch.renderTorchAtAngle(tessellator, (double)x + d1, (double)y + d, (double)z + d2, 0.0D, 0.0D);
-            modelTorch.renderTorchAtAngle(tessellator, (double)x + d3, (double)y + d, (double)z + d4, 0.0D, 0.0D);
+        BlockModelTorch<?> modelTorch = this.block.getLogic().isRepeaterPowered ? modelTorchActive : modelTorchIdle;
+        if (renderBlocks.overbright && this.block.getLogic().isRepeaterPowered) {
+            modelTorch.renderTorchAtAngle(tessellator, (double) tilePos.x() + d1, (double) tilePos.y() + d, (double) tilePos.z() + d2, 0.0D, 0.0D);
+            modelTorch.renderTorchAtAngle(tessellator, (double) tilePos.x() + d3, (double) tilePos.y() + d, (double) tilePos.z() + d4, 0.0D, 0.0D);
         } else if (!renderBlocks.overbright) {
-            modelTorch.renderTorchAtAngle(tessellator, (double)x + d1, (double)y + d, (double)z + d2, 0.0D, 0.0D);
-            modelTorch.renderTorchAtAngle(tessellator, (double)x + d3, (double)y + d, (double)z + d4, 0.0D, 0.0D);
+            modelTorch.renderTorchAtAngle(tessellator, (double) tilePos.x() + d1, (double) tilePos.y() + d, (double) tilePos.z() + d2, 0.0D, 0.0D);
+            modelTorch.renderTorchAtAngle(tessellator, (double) tilePos.x() + d3, (double) tilePos.y() + d, (double) tilePos.z() + d4, 0.0D, 0.0D);
         }
         return true;
     }
+
     @Override
     public boolean shouldItemRender3d() {
         return false;
     }
 
     @Override
-    public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, @NotNull Side side)
-    {
+    public boolean shouldSideBeRendered(@NotNull WorldSource source, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @NotNull Side side) {
         return true;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java
index 83f489b63..4d5fea1bf 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java
@@ -6,100 +6,95 @@ import net.minecraft.core.block.BlockLogicJarButterfly;
 import net.minecraft.core.block.BlockLogicLanternFirefly;
 import net.minecraft.core.block.BlockLogicRope;
 import net.minecraft.core.block.tag.BlockTags;
-import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
+import org.joml.primitives.AABBd;
 
 public class BlockModelRope<T extends BlockLogicRope>
-extends BlockModelStandard<T> {
+    extends BlockModelStandard<T> {
     public BlockModelRope(Block<T> block) {
         super(block);
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
-        WorldSource world = worldSource;
-        Block<?> below;
-        boolean hasFloor = (below = world.getBlock(x, y - 1, z)) != null && below.canPlaceOnSurface();
-        boolean hasBlockNegX = canConnect(world, x, y, z, Side.WEST);
-        boolean hasBlockPosX = canConnect(world, x, y, z, Side.EAST);
-        boolean hasBlockNegY = canConnect(world, x, y, z, Side.BOTTOM) || hasFloor;
-        boolean hasBlockPosY = canConnect(world, x, y, z, Side.TOP);
-        boolean hasBlockNegZ = canConnect(world, x, y, z, Side.NORTH);
-        boolean hasBlockPosZ = canConnect(world, x, y, z, Side.SOUTH);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        Block<?> below = worldSource.getBlock(tilePos.down(new TilePos()));
+        boolean hasFloor = below != null && below.canPlaceOnSurface();
+        boolean hasBlockNegX = canConnect(worldSource, tilePos, Direction.WEST);
+        boolean hasBlockPosX = canConnect(worldSource, tilePos, Direction.EAST);
+        boolean hasBlockNegY = canConnect(worldSource, tilePos, Direction.DOWN) || hasFloor;
+        boolean hasBlockPosY = canConnect(worldSource, tilePos, Direction.UP);
+        boolean hasBlockNegZ = canConnect(worldSource, tilePos, Direction.NORTH);
+        boolean hasBlockPosZ = canConnect(worldSource, tilePos, Direction.SOUTH);
 
 
-        boolean drawKnot =  !(hasBlockNegX && hasBlockPosX && !hasBlockNegY && !hasBlockPosY && !hasBlockNegZ && !hasBlockPosZ) &&
+        boolean drawKnot = !(hasBlockNegX && hasBlockPosX && !hasBlockNegY && !hasBlockPosY && !hasBlockNegZ && !hasBlockPosZ) &&
             !(!hasBlockNegX && !hasBlockPosX && hasBlockNegY && hasBlockPosY && !hasBlockNegZ && !hasBlockPosZ) &&
             !(!hasBlockNegX && !hasBlockPosX && !hasBlockNegY && !hasBlockPosY && hasBlockNegZ && hasBlockPosZ);
 
-        AABB bounds = AABB.fromPool(0, 0, 0, 1, 1, 1);
+        AABBd bounds = new AABBd(0, 0, 0, 1, 1, 1);
 
         final float ropeThickness = (1 / 16f);
         final float knotThickness = (2 / 16f);
         final float pileWidth = (3 / 16f);
 
-        if (drawKnot)
-        {
-            bounds.set(0.5f - knotThickness, 0.5f - knotThickness, 0.5f - knotThickness, 0.5f + knotThickness, 0.5f + knotThickness, 0.5f + knotThickness);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
+        if (drawKnot) {
+            bounds.setMin(0.5f - knotThickness, 0.5f - knotThickness, 0.5f - knotThickness).setMax(0.5f + knotThickness, 0.5f + knotThickness, 0.5f + knotThickness);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
         }
 
-        if (hasBlockPosY)
-        {
-            bounds.set(0.5f - ropeThickness, 0.5f, 0.5f - ropeThickness, 0.5f + ropeThickness, 1, 0.5f + ropeThickness);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
+        if (hasBlockPosY) {
+            bounds.setMin(0.5f - ropeThickness, 0.5f, 0.5f - ropeThickness).setMax(0.5f + ropeThickness, 1, 0.5f + ropeThickness);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
         }
-        if (hasBlockNegY)
-        {
-            bounds.set(0.5f - ropeThickness, 0, 0.5f - ropeThickness, 0.5f + ropeThickness, 0.5f, 0.5f + ropeThickness);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
+        if (hasBlockNegY) {
+            bounds.setMin(0.5f - ropeThickness, 0, 0.5f - ropeThickness).setMax(0.5f + ropeThickness, 0.5f, 0.5f + ropeThickness);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
         }
-        if (hasBlockPosX)
-        {
-            bounds.set(0.5f, 0.5f - ropeThickness, 0.5f - ropeThickness, 1, 0.5f + ropeThickness, 0.5f + ropeThickness);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
+        if (hasBlockPosX) {
+            bounds.setMin(0.5f, 0.5f - ropeThickness, 0.5f - ropeThickness).setMax(1, 0.5f + ropeThickness, 0.5f + ropeThickness);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
         }
-        if (hasBlockNegX)
-        {
-            bounds.set(0, 0.5f - ropeThickness, 0.5f - ropeThickness, 0.5f, 0.5f + ropeThickness, 0.5f + ropeThickness);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
+        if (hasBlockNegX) {
+            bounds.setMin(0, 0.5f - ropeThickness, 0.5f - ropeThickness).setMax(0.5f, 0.5f + ropeThickness, 0.5f + ropeThickness);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
         }
-        if (hasBlockPosZ)
-        {
-            bounds.set(0.5f - ropeThickness, 0.5f - ropeThickness, 0.5f, 0.5f + ropeThickness, 0.5f + ropeThickness, 1);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
+        if (hasBlockPosZ) {
+            bounds.setMin(0.5f - ropeThickness, 0.5f - ropeThickness, 0.5f).setMax(0.5f + ropeThickness, 0.5f + ropeThickness, 1);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
         }
-        if (hasBlockNegZ)
-        {
-            bounds.set(0.5f - ropeThickness, 0.5f - ropeThickness, 0f, 0.5f + ropeThickness, 0.5f + ropeThickness, 0.5f);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
+        if (hasBlockNegZ) {
+            bounds.setMin(0.5f - ropeThickness, 0.5f - ropeThickness, 0f).setMax(0.5f + ropeThickness, 0.5f + ropeThickness, 0.5f);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
         }
-        if (hasFloor){
-            bounds.set(0.5f - pileWidth, 0,0.5f - pileWidth, 0.5f + pileWidth, knotThickness, 0.5f + pileWidth);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
-            bounds.set(0.5f - knotThickness, 0,0.5f - knotThickness, 0.5f + knotThickness, ropeThickness * 3, 0.5f + knotThickness);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
+        if (hasFloor) {
+            bounds.setMin(0.5f - pileWidth, 0, 0.5f - pileWidth).setMax(0.5f + pileWidth, knotThickness, 0.5f + pileWidth);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+            bounds.setMin(0.5f - knotThickness, 0, 0.5f - knotThickness).setMax(0.5f + knotThickness, ropeThickness * 3, 0.5f + knotThickness);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
         }
 
         return true;
     }
-    private boolean canConnect(WorldSource worldSource, int x, int y, int z, Side side){
-        int blockX = x + side.getOffsetX();
-        int blockY = y + side.getOffsetY();
-        int blockZ = z + side.getOffsetZ();
-        Block<?> _block = worldSource.getBlock(blockX, blockY, blockZ);
-        if (side == Side.BOTTOM){ // TODO replace with a proper system for querying what block another block is "attached" to
-            if (Block.hasLogicClass(_block, BlockLogicLanternFirefly.class) && (worldSource.getBlockMetadata(blockX, blockY, blockZ) & 0b1) != 0){
+
+    private boolean canConnect(@NotNull WorldSource worldSource, @NotNull TilePosc tilePos, @NotNull Direction direction) {
+        TilePos shiftedPos = tilePos.add(direction, new TilePos());
+        Block<?> _block = worldSource.getBlock(shiftedPos);
+        if (direction == Direction.DOWN) { // TODO replace with a proper system for querying what block another block is "attached" to
+            if (Block.hasLogicClass(_block, BlockLogicLanternFirefly.class) && (worldSource.getBlockData(shiftedPos) & 0b1) != 0) {
                 return true;
-            } else if (Block.hasLogicClass(_block, BlockLogicJarButterfly.class) && (worldSource.getBlockMetadata(blockX, blockY, blockZ) & 0b1) != 0) {
+            } else if (Block.hasLogicClass(_block, BlockLogicJarButterfly.class) && (worldSource.getBlockData(shiftedPos) & 0b1) != 0) {
                 return true;
             }
-        } else if (side == Side.TOP) {
-            if (worldSource.isBlockOpaqueCube(blockX, blockY, blockZ) || BlockTags.CAN_HANG_OFF.appliesTo(_block)) return true;
+        } else if (direction == Direction.UP) {
+            if (worldSource.isBlockOpaqueCube(shiftedPos) || BlockTags.CAN_HANG_OFF.appliesTo(_block))
+                return true;
         }
-        if ((worldSource.getBlockMetadata(x, y, z) & 0b1000_0000) != 0 && worldSource.isBlockOpaqueCube(blockX, blockY, blockZ)) return true;
-        return _block == block;
+        if ((worldSource.getBlockData(tilePos) & 0b1000_0000) != 0 && worldSource.isBlockOpaqueCube(shiftedPos))
+            return true;
+        return _block == this.block;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRotatable.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRotatable.java
index 78260b389..d73c9d3f5 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRotatable.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRotatable.java
@@ -5,6 +5,7 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.helper.Sides;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class BlockModelRotatable<T extends BlockLogic> extends BlockModelStandard<T> {
@@ -13,9 +14,8 @@ public class BlockModelRotatable<T extends BlockLogic> extends BlockModelStandar
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
-    {
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data) {
         int index = Sides.orientationLookUp[6 * data + side.getId()];
-        return blockTextures.get(Side.getSideById(index));
+        return this.blockTextures.get(Side.getSideById(index));
     }
 }
